/***************************************************************
 * Name:      wxSmithNotepadMain.cpp
 * Purpose:   Code for Application Frame
 * Author:    Herman ()
 * Created:   2014-04-01
 * Copyright: Herman ()
 * License:
 **************************************************************/

#include "wxSmithNotepadMain.h"
#include <wx/msgdlg.h>

//(*InternalHeaders(wxSmithNotepadFrame)
#include <wx/intl.h>
#include <wx/string.h>
//*)

//helper functions
enum wxbuildinfoformat {
    short_f, long_f };

wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-Unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

//(*IdInit(wxSmithNotepadFrame)
const long wxSmithNotepadFrame::ID_TEXTCTRL1 = wxNewId();
const long wxSmithNotepadFrame::ID_BUTTON1 = wxNewId();
const long wxSmithNotepadFrame::idMenuQuit = wxNewId();
const long wxSmithNotepadFrame::ID_MenuOpen = wxNewId();
const long wxSmithNotepadFrame::idMenuAbout = wxNewId();
const long wxSmithNotepadFrame::ID_STATUSBAR1 = wxNewId();
//*)

BEGIN_EVENT_TABLE(wxSmithNotepadFrame,wxFrame)
    //(*EventTable(wxSmithNotepadFrame)
    //*)
END_EVENT_TABLE()

wxSmithNotepadFrame::wxSmithNotepadFrame(wxWindow* parent,wxWindowID id)
{
    //(*Initialize(wxSmithNotepadFrame)
    wxMenuItem* MenuItem2;
    wxMenuItem* MenuItem1;
    wxMenu* Menu1;
    wxMenuBar* MenuBar1;
    wxMenu* Menu2;

    Create(parent, id, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("id"));
    SetClientSize(wxSize(400,330));
    TextCtrl1 = new wxTextCtrl(this, ID_TEXTCTRL1, _("Text"), wxPoint(0,0), wxSize(400,264), wxTE_MULTILINE|wxTE_RICH, wxDefaultValidator, _T("ID_TEXTCTRL1"));
    Button1 = new wxButton(this, ID_BUTTON1, _("FileOpen"), wxPoint(296,280), wxSize(80,39), 0, wxDefaultValidator, _T("ID_BUTTON1"));
    MenuBar1 = new wxMenuBar();
    Menu1 = new wxMenu();
    MenuItem1 = new wxMenuItem(Menu1, idMenuQuit, _("Quit\tAlt-F4"), _("Quit the application"), wxITEM_NORMAL);
    Menu1->Append(MenuItem1);
    MenuItem3 = new wxMenuItem(Menu1, ID_MenuOpen, _("Open\tInput a text file"), wxEmptyString, wxITEM_NORMAL);
    Menu1->Append(MenuItem3);
    MenuBar1->Append(Menu1, _("&File"));
    Menu2 = new wxMenu();
    MenuItem2 = new wxMenuItem(Menu2, idMenuAbout, _("About\tF1"), _("Show info about this application"), wxITEM_NORMAL);
    Menu2->Append(MenuItem2);
    MenuBar1->Append(Menu2, _("Help"));
    SetMenuBar(MenuBar1);
    StatusBar1 = new wxStatusBar(this, ID_STATUSBAR1, 0, _T("ID_STATUSBAR1"));
    int __wxStatusBarWidths_1[1] = { -1 };
    int __wxStatusBarStyles_1[1] = { wxSB_NORMAL };
    StatusBar1->SetFieldsCount(1,__wxStatusBarWidths_1);
    StatusBar1->SetStatusStyles(1,__wxStatusBarStyles_1);
    SetStatusBar(StatusBar1);
    FileDialog1 = new wxFileDialog(this, _("Select input file"), wxEmptyString, wxEmptyString, wxFileSelectorDefaultWildcardStr, wxFD_DEFAULT_STYLE|wxFD_OPEN, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));

    Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&wxSmithNotepadFrame::OnButton1Click);
    Connect(idMenuQuit,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&wxSmithNotepadFrame::OnQuit);
    Connect(ID_MenuOpen,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&wxSmithNotepadFrame::OnMenuOpen);
    Connect(idMenuAbout,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&wxSmithNotepadFrame::OnAbout);
    //*)
}

wxSmithNotepadFrame::~wxSmithNotepadFrame()
{
    //(*Destroy(wxSmithNotepadFrame)
    //*)
}

void wxSmithNotepadFrame::OnQuit(wxCommandEvent& event)
{
    Close();
}

void wxSmithNotepadFrame::OnAbout(wxCommandEvent& event)
{
    wxString msg = wxbuildinfo(long_f);
    wxMessageBox(msg, _("Welcome to..."));
}

void wxSmithNotepadFrame::OnButton1Click(wxCommandEvent& event)
{
    int response = FileDialog1->ShowModal(); //get response from the dialog
    if(response == wxID_OK)
     { //if response ok, then load contents into textControl
     this->TextCtrl1->LoadFile(FileDialog1->GetPath());
     }

}

void wxSmithNotepadFrame::OnMenuOpen(wxCommandEvent& event)
{
    int response = FileDialog1->ShowModal(); //get response from the dialog
    if(response == wxID_OK)
     { //if response ok, then load contents into textControl
     this->TextCtrl1->LoadFile(FileDialog1->GetPath());
}
}
